Package: readMzXmlData
Version: 2.8.4
Date: 2025-10-17
Title: Reads Mass Spectrometry Data in mzXML Format
Authors@R: person("Sebastian", "Gibb", role=c("aut", "cre"),
    email="mail@sebastiangibb.de")
Depends: R (>= 4.2.0)
Imports: base64enc, digest, XML
Description: Functions for reading mass spectrometry data in mzXML format.
License: GPL (>= 3)
URL: https://strimmerlab.github.io/software/maldiquant/
        https://codeberg.org/sgibb/readMzXmlData/
BugReports: https://codeberg.org/sgibb/readMzXmlData/issues/
LazyLoad: yes
RoxygenNote: 7.3.2
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2025-10-17 06:48:33 UTC; sebastian
Author: Sebastian Gibb [aut, cre]
Maintainer: Sebastian Gibb <mail@sebastiangibb.de>
Repository: CRAN
Date/Publication: 2025-10-17 07:10:03 UTC
Built: R 4.6.0; ; 2026-04-25 18:47:39 UTC; unix

Package: readMzXmlData
Version: 2.8.4
Date: 2025-10-17
Title: Reads Mass Spectrometry Data in mzXML Format
Authors@R: person("Sebastian", "Gibb", role=c("aut", "cre"),
    email="mail@sebastiangibb.de")
Depends: R (>= 4.2.0)
Imports: base64enc, digest, XML
Description: Functions for reading mass spectrometry data in mzXML format.
License: GPL (>= 3)
URL: https://strimmerlab.github.io/software/maldiquant/
        https://codeberg.org/sgibb/readMzXmlData/
BugReports: https://codeberg.org/sgibb/readMzXmlData/issues/
LazyLoad: yes
RoxygenNote: 7.3.2
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2025-10-17 06:48:33 UTC; sebastian
Author: Sebastian Gibb [aut, cre]
Maintainer: Sebastian Gibb <mail@sebastiangibb.de>
Repository: CRAN
Date/Publication: 2025-10-17 07:10:03 UTC

## Copyright 2011-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readMzXmlData for R and related languages.
##
## readMzXmlData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readMzXmlData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readMzXmlData. If not, see <https://www.gnu.org/licenses/>

#' Converts XML attributes.
#'
#' This function converts a XML attribute to \code{character}. 
#'
#' @param attributes \code{character}, XML attributes
#' @param attributeName \code{character}, name XML attributes of attribute to
#'  convert
#' @param required \code{logical}, throw an error if an required attribute is
#'  missing.
#'
#' @return \code{character}, attribute string 
#'
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @seealso \code{\link[readMzXmlData]{.attributeToDouble}},
#'  \code{\link[readMzXmlData]{.attributeTimeToDouble}}
#' @rdname attributeToString
#' @keywords internal
#'
.attributeToString <- function(attributes, attributeName, required=FALSE) {
  a <- unname(attributes[attributeName])
  if (required && (is.null(a) || is.na(a))) {
    stop("Malformed mzXML: attribute ", sQuote(attributeName), " is missing!")
  } else {
    return(a)
  }
}

#' Converts XML attributes.
#'
#' This function converts a XML attribute to \code{double}. 
#'
#' @param attributes \code{character}, XML attributes
#' @param attributeName \code{character}, name XML attributes of attribute to
#'  convert
#' @param required \code{logical}, throw an error if an required attribute is
#'  missing.
#'
#' @return \code{double}
#'
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @seealso \code{\link[readMzXmlData]{.attributeToString}},
#'  \code{\link[readMzXmlData]{.attributeTimeToDouble}}
#' @rdname attributeToDouble
#' @keywords internal
#'
.attributeToDouble <- function(attributes, attributeName, required=FALSE) {
  return(as.double(.attributeToString(attributes=attributes,
                                      attributeName=attributeName,
                                      required=required)))
}

#' Converts XML attributes.
#'
#' This function converts a XML time attribute to \code{double}. 
#'
#' @param attributes \code{character}, XML attributes
#' @param attributeName \code{character}, name XML attributes of attribute to
#'  convert
#' @param required \code{logical}, throw an error if an required attribute is
#'  missing.
#'
#' @return \code{double}
#'
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @seealso \code{\link[readMzXmlData]{.attributeToString}},
#'  \code{\link[readMzXmlData]{.attributeToDouble}}
#' @rdname attributeTimeToDouble
#' @keywords internal
#'
.attributeTimeToDouble <- function(attributes, attributeName, required=FALSE) {
  return(as.double(.grepDouble(.attributeToString(attributes=attributes,
                                                  attributeName=attributeName,
                                                  required=required))))
}

## Copyright 2011-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readMzXmlData for R and related languages.
##
## readMzXmlData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readMzXmlData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readMzXmlData. If not, see <https://www.gnu.org/licenses/>

#' Reads mass spectrometry data in mzXML format.
#'
#' Reads mass spectrometry data in mzXML format defined in
#' \url{http://tools.proteomecenter.org/wiki/index.php?title=Formats:mzXML}
#'
#' @param mzXmlFile \code{character}, path to \emph{mzXML} file which should
#'  be read.
#' @param removeMetaData \code{logical}, to save memory metadata could be
#'  deleted.
#' @param verbose \code{logical}, verbose output?
#'
#' @return A list of spectra and metadata.
#'  \item{\code{spectrum$mass}: }{A vector of calculated mass.}
#'  \item{\code{spectrum$intensity}: }{A vector of intensity values.}
#'  \item{\code{metaData}: }{A list of metaData depending on read spectrum.}
#'
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @seealso \code{\link{readMzXmlDir}},
#' \code{\link[MALDIquantForeign]{importMzXml}}
#' @references Definition of \code{mzXML} format:
#' \url{http://tools.proteomecenter.org/wiki/index.php?title=Formats:mzXML}
#'
#' @keywords IO
#' @rdname readMzXmlFile
#' @export
#' @examples
#'
#' ## load library
#' library("readMzXmlData")
#'
#' ## get examples directory
#' exampleDirectory <- system.file("Examples", package="readMzXmlData")
#'
#' ## read example spectrum
#' spec <- readMzXmlFile(file.path(exampleDirectory, "A1-0_A1.mzXML"))
#'
#' ## print metaData
#' print(spec$metaData)
#'
#' ## plot spectrum
#' plot(spec$spectrum$mass, spec$spectrum$intensity, type="l")
#'
readMzXmlFile <- function(mzXmlFile, removeMetaData=FALSE, verbose=FALSE) {
  scans <- .readMzXmlFile(mzXmlFile=mzXmlFile, removeMetaData=removeMetaData,
                          verbose=verbose);

  if (length(scans) <= 1) {
    return(scans[[1]]);
  } else {
    return(scans);
  }
}

#' Reads mass spectrometry data in mzXML format.
#'
#' Internal function.
#
#' @param mzXmlFile \code{character}, path to \emph{mzXML} file which should
#'  be read.
#' @param removeMetaData \code{logical}, to save memory metadata could be
#'  deleted.
#' @param verbose \code{logical}, verbose output?
#'
#' @return A list of spectra and metadata.
#'
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @seealso \code{\link[readMzXmlData]{readMzXmlFile}}
#' @rdname readMzXmlFile-internal
#' @keywords internal
#'
.readMzXmlFile <- function(mzXmlFile, removeMetaData=FALSE, verbose=FALSE) {
  if (verbose) {
    message("Reading spectrum from ", sQuote(mzXmlFile), " ...")
  }

  if (!file.exists(mzXmlFile)) {
    stop("File ", sQuote(mzXmlFile), " doesn't exists!")
  }

  if (file.info(mzXmlFile)$isdir) {
    stop("Not a mzXML file! ", sQuote(mzXmlFile), " is a directory.")
  }

  ## try to get absolute file path
  mzXmlFile <- normalizePath(mzXmlFile)

  ## read file
  s <- .parseMzXml(file=mzXmlFile, verbose=verbose)

  spectra <- lapply(s$scan, function(x, globalS=s) {
    scan <- list()
    scan$spectrum <- x$spectrum
    scan$metaData$file <- mzXmlFile

    if (!removeMetaData) {
      scan$metaData <- c(scan$metaData, globalS$metaData, x$metaData)
    }
    return(scan)
  })

  return(spectra)
}

## Copyright 2011-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readMzXmlData for R and related languages.
##
## readMzXmlData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readMzXmlData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readMzXmlData. If not, see <https://www.gnu.org/licenses/>

#' Parse mzXML files.
#'
#' This function parses mzXML files.
#'
#' @param file \code{character}, path to mzXML file
#' @param verbose \code{logical}, verbose output?
#'
#' @return Returns a list with metadata and spectra.
#'
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @rdname parseMzXml
#' @keywords internal
#'
.parseMzXml <- function(file, verbose=FALSE, ...) {
  return(XML::xmlEventParse(file=file,
                            handlers=.mzXmlHandlers(fileName=file,
                                                    verbose=verbose),
                            addContext=FALSE, useTagName=TRUE, useDotNames=TRUE,
                            ...)$getData())
}

#' Parse mzXML files.
#'
#' This function is defines handlers for XML SAX parser. Internal use only.
#'
#' @param fileName \code{character}, path to mzXML file
#' @param verbose \code{logical}, verbose output?
#'
#' @return function closure
#'
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @references
#' Definition of \code{mzXML} format:
#' \url{http://tools.proteomecenter.org/wiki/index.php?title=Formats:mzXML}
#' @rdname mzXmlHandlers
#' @keywords internal
#'
.mzXmlHandlers <- function(fileName, verbose=FALSE) {
  ## define local variables

  ## handle different mzXML versions
  mzXmlVersion <- 0

  ## save last opened tag (needed for .text()-processing)
  openTag <- ""

  ## store current scan values
  nScans <- 0
  currentScanId <- 0
  currentPeaks <- ""
  precision <- 0
  byteOrder <- ""
  compressionType <- "none"

  ## sha1 tmp values
  sha1Sums <- character()
  currentSha1Id <- 0

  ## build final list
  xml <- list()
  xml$metaData <- list()
  xml$scans <- list()

  ## handlers for specific tags
  ## mzXML
  mzXML <- function(name, attrs) {
    ## fetch version information
    mzXmlVersion <<- .grepDouble(attrs["xmlns"])

    if (verbose) {
      message("Found mzXML document (version: ", mzXmlVersion, ").")
    }
  }

  ## mzXML/msRun
  msRun <- function(name, attrs) {
    ## fetch metadata for a measurement

    ## number of scans in mzXML file
    n <- .attributeToDouble(attrs, "scanCount", required=FALSE)

    nScans <<- ifelse(length(n), n, 1)

    ## optional attributes
    optAttrs <- c("startTime", "endTime")
    m <- lapply(optAttrs, .attributeTimeToDouble, attributes=attrs)
    names(m) <- optAttrs

    m <- m[!is.na(m)]

    xml$metaData <<- c(scanCount=nScans, m)
  }

  ## mzXML/msRun/parentFile
  parentFile <- function(name, attrs) {
    if (is.null(xml$metaData$parentFile)) {
      xml$metaData$parentFile <<- list()
    }

    reqAttrs <- c("fileName", "fileType", "fileSha1")
    p <- lapply(reqAttrs, .attributeToString, attributes=attrs)
    names(p) <- reqAttrs

    l <- length(xml$metaData$parentFile)+1
    xml$metaData$parentFile[[l]] <<- p
  }

  ## mzXML/msRun/msInstrument - children
  msInstrumentChild <- function(name, attrs) {
    if (is.null(xml$metaData$msInstrument)) {
      xml$metaData$msInstrument <<- list()
    }

    xml$metaData$msInstrument[[name]] <<-
      .attributeToString(attrs, "value")
  }

  ## mzXML/msRun/msInstrument/software or
  ## mzXML/msRun/dataProcessing/software
  software <- function(name, attrs) {
    reqAttrs <- c("type", "name", "version")
    optAttrs <- c("completionTime")

    if (openTag == "msInstrument") {
      xml$metaData$msInstrument$software <<- list()
      for (i in reqAttrs) {
        xml$metaData$msInstrument$software[[i]] <<-
          .attributeToString(attrs, i, required=TRUE)
      }
      for (i in optAttrs) {
        a <- .attributeToString(attrs, i)
        if (!is.na(a)) {
          xml$metaData$msInstrument$software[[i]] <<- a
        }
      }
    } else if (openTag == "dataProcessing") {
      if (is.null(xml$metaData$dataProcessing$software)) {
        xml$metaData$dataProcessing$software <<- list()
      }

      l <- length(xml$metaData$dataProcessing$software)+1
      xml$metaData$dataProcessing$software[[l]] <<- list()
      for (i in reqAttrs) {
        xml$metaData$dataProcessing$software[[l]][[i]] <<-
          .attributeToString(attrs, i, required=TRUE)
      }
      for (i in optAttrs) {
        a <- .attributeToString(attrs, i)
        if (!is.na(a)) {
          xml$metaData$dataProcessing$software[[l]][[i]] <<- a
        }
      }
    }
  }

  ## mzXML/msRun/msInstrument/operator
  operator <- function(name, attrs) {
    reqAttrs <- c("first", "last")
    optAttrs <- c("email", "phone", "URI")
    xml$metaData$msInstrument$operator <<- list()

    for (i in reqAttrs) {
      xml$metaData$msInstrument$operator[[i]] <<-
        .attributeToString(attrs, i, required=TRUE)
    }
    for (i in optAttrs) {
      a <- .attributeToString(attrs, i)
      if (!is.na(a)) {
        xml$metaData$msInstrument$operator[[i]] <<- a
      }
    }
  }

  ## mzXML/msRun/dataProcessing
  dataProcessing <- function(name, attrs) {
    if (is.null(xml$metaData$dataProcessing)) {
      xml$metaData$dataProcessing <<- list()
    }

    openTag <<- "dataProcessing"
    optAttrs <- c("intensityCutoff", "centroided", "chargeDeconvoluted",
                  "deisotoped", "spotIntegration")

    for (i in optAttrs) {
      a <- .attributeToDouble(attrs, i)
      if (length(a) && !is.na(a)) {
        xml$metaData$dataProcessing[[i]] <<- a
      }
    }
  }

  ## mzXML/msRun/dataProcessing/processingOperation
  processingOperation <- function(name, attrs) {
    optAttrs <- c("name", "value", "type")

    operations <- list()

    for (i in optAttrs) {
      a <- .attributeToString(attrs, i)
      if (!is.na(a)) {
        operations[[i]] <- a
      }
    }

    if (length(operations)) {
      if (is.null(xml$metaData$dataProcessing$operations)) {
        xml$metaData$dataProcessing$operations <<- list()
      }
      l <- length(xml$metaData$dataProcessing$operations)
      xml$metaData$dataProcessing$operations[[l+1]] <<- operations
    }
  }

  ## mzXML/msRun/scan
  scan <- function(name, attrs) {
    currentScanId <<- currentScanId + 1

    reqAttrs <- c("num", "peaksCount")
    optAttrsStr <- c("polarity", "scanType", "collisionGas", "filterLine")
    optAttrsDouble <- c("centroided", "chargeDeconvoluted", "deisotoped",
                        "ionisationEnergy", "collisionEnergy",
                        "collisionGasPressure", "cidGasPressure",
                        "startMz", "endMz", "lowMz",
                        "highMz", "basePeakMz", "basePeakIntensity",
                        "totIonCurrent", "msInstrumentID",
                        "compensationVoltage")
    optAttrsTime <- c("retentionTime")

    xml$scans[[currentScanId]] <<- list()
    xml$scans[[currentScanId]]$metaData <<- list()

    for (i in reqAttrs) {
      xml$scans[[currentScanId]]$metaData[[i]] <<-
          .attributeToDouble(attrs, i, required=TRUE)
    }

    ## msLevel is required in mzXML specification
    ## to read malformed files missing is allowed
    msLevel <- .attributeToDouble(attrs, "msLevel", required=FALSE)

    if (is.na(msLevel)) {
      msLevel <- 1
      warning("Malformed mzXML: 'msLevel' attribute is missing!\n",
              "'msLevel' == 1 is assumed.")
    }

    xml$scans[[currentScanId]]$metaData[["msLevel"]] <<- msLevel

    for (i in optAttrsStr) {
      a <- .attributeToString(attrs, i)
      if (!is.na(a)) {
        xml$scans[[currentScanId]]$metaData[[i]] <<- a
      }
    }
    for (i in optAttrsDouble) {
      a <- .attributeToDouble(attrs, i)
      if (!is.na(a)) {
        xml$scans[[currentScanId]]$metaData[[i]] <<- a
      }
    }
    for (i in optAttrsTime) {
      a <- .attributeTimeToDouble(attrs, i)
      if (!is.na(a)) {
        xml$scans[[currentScanId]]$metaData[[i]] <<- a
      }
    }

    if (verbose) {
      message("Processing scan ", currentScanId, "/", nScans,
              " (msLevel: ", attrs["msLevel"],
              ", number of peaks: ", attrs["peaksCount"], ") ...")
    }
  }

  ## mzXML/msRun/scan/scanOrigin
  scanOrigin <- function(name, attrs) {
    if (is.null(xml$scan[[currentScanId]]$metaData$scanOrigin)) {
      xml$scan[[currentScanId]]$metaData$scanOrigin <<- list()
    }

    o <- list()
    o$parentFileID <- .attributeToString(attrs, "parentFileID", required=TRUE)
    o$num <- .attributeToDouble(attrs, "num", required=TRUE)

    xml$scan[[currentScanId]]$metaData$scanOrigin[[o$num]] <<- o
  }

  ## mzXML/msRun/scan/precursorMz
  precursorMz <- function(name, attrs) {
    openTag <<- "precursorMz"

    optAttrsStr <- c("activationMethod")
    optAttrsDouble <- c("precursorCharge", "precursorIntensity",
                        "precursorScanNum", "windowWideness")
    xml$scans[[currentScanId]]$metaData$precursor <<- list()

    for (i in optAttrsStr) {
      a <- .attributeToString(attrs, i)
      if (!is.na(a)) {
        xml$scans[[currentScanId]]$metaData$precursor[[i]] <<- a
      }
    }
    for (i in optAttrsDouble) {
      a <- .attributeToDouble(attrs, i)
      if (!is.na(a)) {
        xml$scans[[currentScanId]]$metaData$precursor[[i]] <<- a
      }
    }
  }

  ## mzXML/msRun/scan/maldi
  maldi <- function(name, attrs) {
    maldi <- list()
    reqAttrs <- c("plateID", "spotID")
    optAttrs <- c("laserShootCount", "laserFrequency", "laserIntensity")

    for (i in reqAttrs) {
      maldi[[i]] <- .attributeToString(attrs, i, required=TRUE)
    }
    for (i in optAttrs) {
      a <- .attributeToString(attrs, i)
      if (!is.na(a)) {
        maldi[[i]] <- .attributeToString(attrs, i)
      }
    }

    xml$scans[[currentScanId]]$metaData$maldi <<- maldi
  }

  ## mzXML/msRun/scan/peaks
  peaks <- function(name, attrs) {
    openTag <<- "peaks"

    precision <<- .attributeToDouble(attrs, "precision", required=TRUE)
    byteOrder <<- .attributeToString(attrs, "byteOrder", required=TRUE)

    xml$scans[[currentScanId]]$metaData$precision <<- precision
    xml$scans[[currentScanId]]$metaData$byteOrder <<- byteOrder

    ## handle different versions
    if (mzXmlVersion < 3) {
      pairOrder <- .attributeToString(attrs, "pairOrder", required=TRUE)

      if (pairOrder != "m/z-int") {
        stop("Malformed mzXML: incorrect 'pairOrder' attribute ",
             "of 'peaks' field!")
      }

      xml$scans[[currentScanId]]$metaData$pairOrder <<- pairOrder

    } else {
      contentType <- .attributeToString(attrs, "contentType", required=TRUE)

      validContentTypes <- c("m/z-int", "m/z", "m/z ruler", "TOF", "intensity",
                             "S/N", "charge")

      if (!contentType %in% validContentTypes) {
        stop("Malformed mzXML: incorrect 'contentType' attribute ",
             "of 'peaks' field!")
      }

      xml$scans[[currentScanId]]$metaData$contentType <<- contentType

      ## compression
      compressionType <<- .attributeToString(attrs, "compressionType",
                                             required=TRUE)

      validCompressionTypes <- c("none", "zlib")

      if (!compressionType %in% validCompressionTypes) {
        stop("Malformed mzXML: incorrect 'compressionType' attribute ",
             "of 'peaks' field!")
      }

      compressedLen <- .attributeToDouble(attrs, "compressedLen",
                                          required=TRUE)

      xml$scans[[currentScanId]]$metaData$compressionType <<- compressionType
      xml$scans[[currentScanId]]$metaData$compressedLen <<- compressedLen

      compressionType <<- ifelse(compressionType == "zlib", "gzip", "none")
    }
  }

  ## mzXML/msRun/sha1 or
  ## mzXML/sha1
  sha1 <- function(name, attrs) {
    openTag <<- "sha1"
    currentSha1Id <<- currentSha1Id+1
    sha1Sums[currentSha1Id] <<- ""
  }

  ## default functions to catch tags without a handler
  .startElement <- function(name, attrs) {
    if (openTag == "msInstrument") {
      return(msInstrumentChild(name=name, attrs=attrs))
    } else {
      openTag <<- name
    }
  }

  .endElement <- function(name, attrs) {
    if (name == "peaks") {
      decodePeaks()
      ## clear peaks
      currentPeaks <<- ""
    }

    if (openTag == name) {
      openTag <<- ""
    }
  }

  .text <- function(x) {
    if (openTag == "precursorMz") {
      xml$scans[[currentScanId]]$metaData$precursorMz <<- as.double(x)
    } else if (openTag == "peaks") {
      currentPeaks <<- paste0(currentPeaks, x)
    } else if (openTag == "sha1") {
      sha1Sums[currentSha1Id] <<- paste0(sha1Sums[currentSha1Id], x)
    }
  }

  ## helper functions
  decodePeaks <- function() {
    ## read base64 encoded peak information
    if (byteOrder == "network") {
      endian <- "big"
    } else {
      endian <- "little"
    }

    size <- round(precision/8)

    if (size != 4 && size != 8) {
      stop("Malformed mzXML: incorrect 'precision' attribute of ",
           "'peaks' field!")
    }

    peaksCount <- xml$scans[[currentScanId]]$metaData$peaksCount

    if (peaksCount>0) {
      p <- .base64decode(x=currentPeaks, endian=endian, size=size,
                         compressionType=compressionType)
      np <- length(p) %/% 2

      if (np != peaksCount) {
        stop("Malformed mzXML: incorrect 'peakCount' attribute of ",
             "'peaks' field: expected ", peaksCount, ", found ",
             np, "  ", (3*((nchar(currentPeaks)*size)/4))/2, " (scan #",
             currentScanId, ")")
      }

      dim(p) <- c(2, np)
      mass <- p[1,]
      intensity <- p[2,]
    } else {
      mass <- double()
      intensity <- double()
    }

    xml$scans[[currentScanId]]$spectrum <<- list(mass=mass, intensity=intensity)
  }

  calculateSha1Sums <- function() {
    n <- length(sha1Sums)
    if (n <= 0) {
      return()
    }

    ## sha1 sum for this file (from the beginning of the file up to (and
    ## including) the opening tag <sha1>
    if (verbose) {
      message("Look for '<sha1>' positions ...")
    }
    sha1Pos <- .revfregexpr("<sha1>", fileName) + 6 # 6 == length("<sha1>")
    ## multiple sha1 sections are possible
    for (i in n) {
      if (verbose) {
        message("Calculate sha1-sum (", i, "/", n, ") for ", sQuote(fileName),
                ": ", appendLF=FALSE)
      }

      sha1Calc <- digest::digest(fileName, algo="sha1", file=TRUE,
                                 length=sha1Pos[i]-1)

      if (verbose) {
        message(sha1Calc)
      }

      if (sha1Sums[i] != sha1Calc) {
        warning("Stored and calculated Sha-1 sums do not match ",
                "(stored ", sQuote(sha1Sums[i]), " calculated ",
                sQuote(sha1Calc), ")!")
      }
    }
  }

  ## return statement (please call getData())
  return(list(getData=function() {return(xml)},
              mzXML=mzXML,
              msRun=msRun,
              parentFile=parentFile,
              software=software,
              operator=operator,
              dataProcessing=dataProcessing,
              processingOperation=processingOperation,
              scan=scan,
              scanOrigin=scanOrigin,
              precursorMz=precursorMz,
              maldi=maldi,
              peaks=peaks,
              sha1=sha1,
              .endDocument=calculateSha1Sums,
              .startElement=.startElement,
              .endElement=.endElement,
              .text=.text))
}

## Copyright 2011-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readMzXmlData for R and related languages.
##
## readMzXmlData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readMzXmlData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readMzXmlData. If not, see <https://www.gnu.org/licenses/>

#' Reads recursively mass spectrometry data in mzXML format.
#'
#' Reads recursively all mass spectrometry data in mzXML format in a specified
#' directory.
#'
#' @details See \code{\link{readMzXmlFile}}.
#'
#' @param mzXmlDir \code{character}, path to \emph{directory} which should
#'  be read recursively.
#' @param removeCalibrationScans \code{logical}, if \code{TRUE} all scans in
#'  directories called \dQuote{[Cc]alibration} will be ignored.
#' @param removeMetaData \code{logical}, to save memory metadata could be
#'  deleted.
#' @param rewriteNames \code{logical}, if \code{TRUE} all list elements get
#'  an unique name from metadata otherwise file path is used.
#' @param fileExtension \code{character}, file extension of mzXML formatted
#'  files. The directory is only searched for \emph{fileExtension} files.
#'  In most cases it would be \dQuote{"mzXML"} but sometimes you have to use
#'  \dQuote{xml}.
#' @param verbose \code{logical}, verbose output?
#'
#' @return A list of spectra.
#'  \item{\code{[[1]]spectrum$mass}: }{A vector of calculated mass.}
#'  \item{\code{[[1]]spectrum$intensity}: }{A vector of intensity values.}
#'  \item{\code{[[1]]metaData}: }{A list of metaData depending on read spectrum.}
#'
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @seealso \code{\link{readMzXmlFile}},
#' \code{\link[MALDIquantForeign]{importMzXml}}
#' @keywords IO
#' @rdname readMzXmlDir
#' @export
#' @examples
#'
#' ## load library
#' library("readMzXmlData")
#'
#' ## get examples directory
#' exampleDirectory <- system.file("Examples", package="readMzXmlData")
#'
#' ## read example spectra
#' spec <- readMzXmlDir(exampleDirectory)
#'
#' ## plot spectra
#' plot(spec[[1]]$spectrum$mass, spec[[1]]$spectrum$intensity, type="n")
#'
#' l <- length(spec)
#' legendStr <- character(l)
#' for (i in seq(along=spec)) {
#'   lines(spec[[i]]$spectrum$mass, spec[[i]]$spectrum$intensity, type="l",
#'         col=rainbow(l)[i])
#'   legendStr[i] <- basename(spec[[i]]$metaData$file)
#' }
#'
#' ## draw legend
#' legend(x="topright", legend=legendStr, col=rainbow(l), lwd=1)
#'
readMzXmlDir <- function(mzXmlDir, removeCalibrationScans=TRUE,
  removeMetaData=FALSE, rewriteNames=TRUE, fileExtension="mzXML",
  verbose=FALSE) {
  if (verbose) {
    message("Look for spectra in ", sQuote(mzXmlDir), " ...")
  }

  if ((!file.exists(mzXmlDir)) || (!file.info(mzXmlDir)$isdir)) {
    stop("Directory ", sQuote(mzXmlDir), " doesn't exists or is no ",
         "directory!")
  }

  ## look for mzXML files (alphabetical sort)
  files <- list.files(path=mzXmlDir,
                      pattern=paste0("^.*\\.", fileExtension, "$"),
                      recursive=TRUE)

  ## remove calibrations scans?
  if (removeCalibrationScans) {
    calibrationScans <- grep(pattern="[Cc]alibration", x=files, value=TRUE)
    if (length(calibrationScans) > 0) {
      files <- setdiff(files, calibrationScans)
    }
  }

  if (length(files) <= 0) {
    stop("Directory doesn't contain any ", fileExtension, " file.")
  }

  ## generate "path/files"
  files <- sapply(files, function(x) {
    x <- file.path(mzXmlDir, x)
    return(x)
  })

  ## read mzXML files
  mzXmlData <- list()
  for (i in seq(along=files)) {
    mzXmlFile <- .readMzXmlFile(mzXmlFile=files[i],
                                removeMetaData=removeMetaData, verbose=verbose)
    for (j in seq(along=mzXmlFile)) {
      spectra <- list()
      spectra$spectra <- mzXmlFile[[j]]
      mzXmlData <- c(mzXmlData, spectra)
    }
  }

  if (!removeMetaData & rewriteNames) {
    ## rewrite names
    if (verbose) {
      message("rewrite names ...")
    }

    names(mzXmlData) <- paste0("s", 1:length(mzXmlData))
  }

  return(mzXmlData)
}

## Copyright 2011-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readMzXmlData for R and related languages.
##
## readMzXmlData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readMzXmlData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readMzXmlData. If not, see <https://www.gnu.org/licenses/>

#' Converts base64 character to double.
#'
#' This function converts a base64 encoded \code{character} vector to a
#' \code{double} vector.
#'
#' @param x \code{character}, base64 encoded string.
#' @param size \code{integer}, number of bytes per element in the byte stream
#'  (see \code{size} in \code{\link[base]{readBin}}).
#' @param endian \code{character}, the endian-ness
#'  (see \code{endian} in \code{\link[base]{readBin}}).
#' @param compressionType \code{character}, type of compression to use for
#'  decompression of \code{x} (see \code{type} in
#'  \code{\link[base]{memDecompress}}.
#' @return Vector of type \code{double}.
#' @rdname base64-decode
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @seealso \code{\link[base64enc]{base64decode}} from \pkg{base64enc} package
#' @keywords internal
#
.base64decode <- function(x, size, endian=.Platform$endian,
                          compressionType=c("none", "gzip")) {
  x <- base64enc::base64decode(x)
  r <- as.raw(x)

  compressionType <- match.arg(compressionType, choices=c("none", "gzip"),
                               several.ok=FALSE)
  r <- memDecompress(from=r, type=compressionType)

  return(readBin(r, what="double", n=length(r)%/%size, size=size, signed=TRUE,
                 endian=endian))
}

## Copyright 2012-2014 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readMzXmlData for R and related languages.
##
## readMzXmlData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readMzXmlData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readMzXmlData. If not, see <https://www.gnu.org/licenses/>

#' The readMzXmlData Package
#'
#' The package reads mass spectrometry data in mzXML format. \cr
#'
#' Main functions:
#'
#' \code{\link{readMzXmlFile}}: Reads mass spectrometry data in mzXML format.
#'
#' \code{\link{readMzXmlDir}}: Reads recursively mass spectrometry data in mzXML
#' format in a specific directory.
#'
#' \code{\link{mqReadMzXml}}: Reads mass spectrometry data into MALDIquant.
#'
#' @name readMzXmlData-package
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @seealso \code{\link{readMzXmlDir}}, \code{\link{readMzXmlFile}}
#' @references See website: \url{https://strimmerlab.github.io/software/maldiquant/}
#' @keywords IO
#'
#' @importFrom base64enc base64decode
#' @importFrom digest digest
#' @importFrom utils tail
#' @importFrom XML xmlEventParse
"_PACKAGE"

#' These functions are defunct and no longer available.
#'
#' \describe{
#'  \item{mqReadMzXml:}{use
#'    \code{\link[MALDIquantForeign]{importMzXml}} instead.}
#' }
#'
#' @title Removed functions in package \pkg{readMzXmlData}
#' @keywords internal
#' @name readMzXmlData-defunct
#' @aliases mqReadMzXml
#' @rdname readMzXmlData-defunct
#'
NULL

## Copyright 2011-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readMzXmlData for R and related languages.
##
## readMzXmlData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readMzXmlData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readMzXmlData. If not, see <https://www.gnu.org/licenses/>

#' Pattern matching.
#'
#' This function returns a substring selected by a regular expression.
#'
#' @param pattern \code{character}, regexp pattern
#' @param x \code{character}, text
#'
#' @return \code{character}, matched substring
#'
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @seealso \code{\link[readMzXmlData]{.grepNumber}}
#' @rdname grepSubString
#' @keywords internal
#'
.grepSubString <- function(pattern, x) {
  rx <- regexpr(pattern=pattern, text=x)
  str <- substr(x=x, start=rx, stop=(rx + (attr(rx, "match.length") - 1) ))
  return(str)
}

#' Pattern matching.
#'
#' This function returns \code{numeric} values found in a \code{character}.
#'
#' @param x \code{character}, text
#'
#' @return \code{numeric}, matched value
#'
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @seealso \code{\link[readMzXmlData]{.grepDouble}}
#'  \code{\link[readMzXmlData]{.grepSubString}}
#' @rdname grepNumber
#' @keywords internal
#'
.grepNumber <- function(x) {
  return(.grepSubString(pattern="[0-9]+\\.?[0-9]*", x=x))
}

#' Pattern matching.
#'
#' This function returns \code{double} values found in a \code{character}.
#'
#' @param x \code{character}, text
#'
#' @return \code{double}, matched value
#'
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @seealso \code{\link[readMzXmlData]{.grepNumber}}
#'  \code{\link[readMzXmlData]{.grepSubString}}
#' @rdname grepDouble
#' @keywords internal
#'
.grepDouble <- function(x) {
  return(as.double(.grepNumber(x)))
}

## Copyright 2011-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readMzXmlData for R and related languages.
##
## readMzXmlData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readMzXmlData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readMzXmlData. If not, see <https://www.gnu.org/licenses/>

#' Pattern matching.
#'
#' This function looks for the last match to argument \code{pattern} in a file
#' \code{file}.
#'
#' @param pattern \code{character}, string containing a regular expression.
#' @param file \code{character}, file path.
#'
#' @return \code{double}, position of match.
#'
#' @rdname revfregexpr
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @keywords internal
#'
.revfregexpr <- function(pattern, file) {
  bufferSize <- 1024L
  size <- file.info(file)$size
  pos <- double()
  f <- file(file, "rb")

  if (size < bufferSize) {
    bufferSize <- size
  }

  readPos <- c(seq(from=size-bufferSize, to=0, by=-bufferSize), 0)
  n <- length(readPos)
  readBufferSize <- c(rep(bufferSize, n-1), readPos[n-1])

  for (i in seq(along=readPos)) {
    seek(f, where=readPos[i])

    p <- gregexpr(pattern=pattern,
                  text=readChar(f, nchars=readBufferSize[i]))[[1]]

    if (p[1] > 0) {
      pos <- readPos[i]+tail(p, 1)
      break
    }
  }
  close(f)

  return(pos)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grep-functions.R
\name{.grepNumber}
\alias{.grepNumber}
\title{Pattern matching.}
\usage{
.grepNumber(x)
}
\arguments{
\item{x}{\code{character}, text}
}
\value{
\code{numeric}, matched value
}
\description{
This function returns \code{numeric} values found in a \code{character}.
}
\seealso{
\code{\link[readMzXmlData]{.grepDouble}}
 \code{\link[readMzXmlData]{.grepSubString}}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parseMzXml.R
\name{.mzXmlHandlers}
\alias{.mzXmlHandlers}
\title{Parse mzXML files.}
\usage{
.mzXmlHandlers(fileName, verbose = FALSE)
}
\arguments{
\item{fileName}{\code{character}, path to mzXML file}

\item{verbose}{\code{logical}, verbose output?}
}
\value{
function closure
}
\description{
This function is defines handlers for XML SAX parser. Internal use only.
}
\references{
Definition of \code{mzXML} format:
\url{http://tools.proteomecenter.org/wiki/index.php?title=Formats:mzXML}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/base64-functions.R
\name{.base64decode}
\alias{.base64decode}
\title{Converts base64 character to double.}
\usage{
.base64decode(
  x,
  size,
  endian = .Platform$endian,
  compressionType = c("none", "gzip")
)
}
\arguments{
\item{x}{\code{character}, base64 encoded string.}

\item{size}{\code{integer}, number of bytes per element in the byte stream
(see \code{size} in \code{\link[base]{readBin}}).}

\item{endian}{\code{character}, the endian-ness
(see \code{endian} in \code{\link[base]{readBin}}).}

\item{compressionType}{\code{character}, type of compression to use for
decompression of \code{x} (see \code{type} in
\code{\link[base]{memDecompress}}.}
}
\value{
Vector of type \code{double}.
}
\description{
This function converts a base64 encoded \code{character} vector to a
\code{double} vector.
}
\seealso{
\code{\link[base64enc]{base64decode}} from \pkg{base64enc} package
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readMzXmlDir-functions.R
\name{readMzXmlDir}
\alias{readMzXmlDir}
\title{Reads recursively mass spectrometry data in mzXML format.}
\usage{
readMzXmlDir(
  mzXmlDir,
  removeCalibrationScans = TRUE,
  removeMetaData = FALSE,
  rewriteNames = TRUE,
  fileExtension = "mzXML",
  verbose = FALSE
)
}
\arguments{
\item{mzXmlDir}{\code{character}, path to \emph{directory} which should
be read recursively.}

\item{removeCalibrationScans}{\code{logical}, if \code{TRUE} all scans in
directories called \dQuote{[Cc]alibration} will be ignored.}

\item{removeMetaData}{\code{logical}, to save memory metadata could be
deleted.}

\item{rewriteNames}{\code{logical}, if \code{TRUE} all list elements get
an unique name from metadata otherwise file path is used.}

\item{fileExtension}{\code{character}, file extension of mzXML formatted
files. The directory is only searched for \emph{fileExtension} files.
In most cases it would be \dQuote{"mzXML"} but sometimes you have to use
\dQuote{xml}.}

\item{verbose}{\code{logical}, verbose output?}
}
\value{
A list of spectra.
 \item{\code{[[1]]spectrum$mass}: }{A vector of calculated mass.}
 \item{\code{[[1]]spectrum$intensity}: }{A vector of intensity values.}
 \item{\code{[[1]]metaData}: }{A list of metaData depending on read spectrum.}
}
\description{
Reads recursively all mass spectrometry data in mzXML format in a specified
directory.
}
\details{
See \code{\link{readMzXmlFile}}.
}
\examples{

## load library
library("readMzXmlData")

## get examples directory
exampleDirectory <- system.file("Examples", package="readMzXmlData")

## read example spectra
spec <- readMzXmlDir(exampleDirectory)

## plot spectra
plot(spec[[1]]$spectrum$mass, spec[[1]]$spectrum$intensity, type="n")

l <- length(spec)
legendStr <- character(l)
for (i in seq(along=spec)) {
  lines(spec[[i]]$spectrum$mass, spec[[i]]$spectrum$intensity, type="l",
        col=rainbow(l)[i])
  legendStr[i] <- basename(spec[[i]]$metaData$file)
}

## draw legend
legend(x="topright", legend=legendStr, col=rainbow(l), lwd=1)

}
\seealso{
\code{\link{readMzXmlFile}},
\code{\link[MALDIquantForeign]{importMzXml}}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{IO}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grep-functions.R
\name{.grepDouble}
\alias{.grepDouble}
\title{Pattern matching.}
\usage{
.grepDouble(x)
}
\arguments{
\item{x}{\code{character}, text}
}
\value{
\code{double}, matched value
}
\description{
This function returns \code{double} values found in a \code{character}.
}
\seealso{
\code{\link[readMzXmlData]{.grepNumber}}
 \code{\link[readMzXmlData]{.grepSubString}}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/package.R
\docType{package}
\name{readMzXmlData-package}
\alias{readMzXmlData}
\alias{readMzXmlData-package}
\title{The readMzXmlData Package}
\description{
The package reads mass spectrometry data in mzXML format. \cr
}
\details{
Main functions:

\code{\link{readMzXmlFile}}: Reads mass spectrometry data in mzXML format.

\code{\link{readMzXmlDir}}: Reads recursively mass spectrometry data in mzXML
format in a specific directory.

\code{\link{mqReadMzXml}}: Reads mass spectrometry data into MALDIquant.
}
\references{
See website: \url{https://strimmerlab.github.io/software/maldiquant/}
}
\seealso{
\code{\link{readMzXmlDir}}, \code{\link{readMzXmlFile}}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{IO}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grep-functions.R
\name{.grepSubString}
\alias{.grepSubString}
\title{Pattern matching.}
\usage{
.grepSubString(pattern, x)
}
\arguments{
\item{pattern}{\code{character}, regexp pattern}

\item{x}{\code{character}, text}
}
\value{
\code{character}, matched substring
}
\description{
This function returns a substring selected by a regular expression.
}
\seealso{
\code{\link[readMzXmlData]{.grepNumber}}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/attribute-functions.R
\name{.attributeTimeToDouble}
\alias{.attributeTimeToDouble}
\title{Converts XML attributes.}
\usage{
.attributeTimeToDouble(attributes, attributeName, required = FALSE)
}
\arguments{
\item{attributes}{\code{character}, XML attributes}

\item{attributeName}{\code{character}, name XML attributes of attribute to
convert}

\item{required}{\code{logical}, throw an error if an required attribute is
missing.}
}
\value{
\code{double}
}
\description{
This function converts a XML time attribute to \code{double}.
}
\seealso{
\code{\link[readMzXmlData]{.attributeToString}},
 \code{\link[readMzXmlData]{.attributeToDouble}}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readMzXmlFile-functions.R
\name{readMzXmlFile}
\alias{readMzXmlFile}
\title{Reads mass spectrometry data in mzXML format.}
\usage{
readMzXmlFile(mzXmlFile, removeMetaData = FALSE, verbose = FALSE)
}
\arguments{
\item{mzXmlFile}{\code{character}, path to \emph{mzXML} file which should
be read.}

\item{removeMetaData}{\code{logical}, to save memory metadata could be
deleted.}

\item{verbose}{\code{logical}, verbose output?}
}
\value{
A list of spectra and metadata.
 \item{\code{spectrum$mass}: }{A vector of calculated mass.}
 \item{\code{spectrum$intensity}: }{A vector of intensity values.}
 \item{\code{metaData}: }{A list of metaData depending on read spectrum.}
}
\description{
Reads mass spectrometry data in mzXML format defined in
\url{http://tools.proteomecenter.org/wiki/index.php?title=Formats:mzXML}
}
\examples{

## load library
library("readMzXmlData")

## get examples directory
exampleDirectory <- system.file("Examples", package="readMzXmlData")

## read example spectrum
spec <- readMzXmlFile(file.path(exampleDirectory, "A1-0_A1.mzXML"))

## print metaData
print(spec$metaData)

## plot spectrum
plot(spec$spectrum$mass, spec$spectrum$intensity, type="l")

}
\references{
Definition of \code{mzXML} format:
\url{http://tools.proteomecenter.org/wiki/index.php?title=Formats:mzXML}
}
\seealso{
\code{\link{readMzXmlDir}},
\code{\link[MALDIquantForeign]{importMzXml}}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{IO}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/revfregexpr-functions.R
\name{.revfregexpr}
\alias{.revfregexpr}
\title{Pattern matching.}
\usage{
.revfregexpr(pattern, file)
}
\arguments{
\item{pattern}{\code{character}, string containing a regular expression.}

\item{file}{\code{character}, file path.}
}
\value{
\code{double}, position of match.
}
\description{
This function looks for the last match to argument \code{pattern} in a file
\code{file}.
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readMzXmlFile-functions.R
\name{.readMzXmlFile}
\alias{.readMzXmlFile}
\title{Reads mass spectrometry data in mzXML format.}
\usage{
.readMzXmlFile(mzXmlFile, removeMetaData = FALSE, verbose = FALSE)
}
\arguments{
\item{mzXmlFile}{\code{character}, path to \emph{mzXML} file which should
be read.}

\item{removeMetaData}{\code{logical}, to save memory metadata could be
deleted.}

\item{verbose}{\code{logical}, verbose output?}
}
\value{
A list of spectra and metadata.
}
\description{
Internal function.
}
\seealso{
\code{\link[readMzXmlData]{readMzXmlFile}}
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parseMzXml.R
\name{.parseMzXml}
\alias{.parseMzXml}
\title{Parse mzXML files.}
\usage{
.parseMzXml(file, verbose = FALSE, ...)
}
\arguments{
\item{file}{\code{character}, path to mzXML file}

\item{verbose}{\code{logical}, verbose output?}
}
\value{
Returns a list with metadata and spectra.
}
\description{
This function parses mzXML files.
}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{internal}
